from sys import argv
from subprocess import Popen    
from os import path
from bge import logic
import socket
# import os,sys
# sys.stdout = open(os.devnull, "w")

class Popen_curse:
    """
    Kills process when
    garbage collector(game exit) starts
    """
    def __init__(self,obj):
        self.obj =  obj
    def __del__(self):
        Popen.kill(self.obj)


def launch():
    """
    Popens,meaning to pop open with Popen,
    everything needed for
    socket driven realtime mesh creation.
    """
    cont    = logic.getCurrentController()
    own     = cont.owner
    
    blender_path    = argv[0]
    local_path      = logic.expandPath("//")
 
    folderPath = path.join(local_path, "multiplayerLogic")
        
    server  = Popen( [blender_path, "--background", path.join(local_path, "worker.blend"), "-P", path.join(folderPath, "multiplayerServer.py")])

    logic.multiPlayerServer        = Popen_curse(server)


def isServerOpen(SERVER_IP,PORT):
    
    s = socket.socket()   
    s.settimeout(0.2)
    isOpen = True
    try:
        s.connect((SERVER_IP, PORT)) 
    except :         
        isOpen = False
    s.close()
    
    return isOpen