from mathutils import Vector
from random import random
import time


def generate(dx,dy,chunkSize, dzi):

    scale = 0.5
    s,n, h, c = 2, chunkSize,1 ,0 
    boxList = []

    blockSet = set()
    blocks = []
    varX = 0.5*n
    varY = 0.5*n

    varZ = random()/2+0.5
    d = 2 #wall thickness
    wall1 = range(0,d)
    wall2 = range(n-d,n)
    wall = list(wall1)+list(wall2)
    for dz in range(dzi):
        
        choice = int(random()*4)
        for x in wall:
            for y in range(0,n):
                for z in range(1,n):
                    if choice:
                        v = Vector((x,y,z))-Vector((n/2,n/2,n/2))
                        #if v.length<n*0.6: continue
                        if (abs(y-varY)<0.25*n) : continue
                    pos = [x+dx*n,y+dy*n,z+dz*n,4]
                    if tuple(pos[:3]) not in blockSet:
                        blockSet.add(tuple(pos[:3]))
                        blocks.append(pos)
        choice = int(random()*4)            
        for y in wall:
            for x in range(0,n):
                for z in range(1,n):
                    if  choice:
                        v = Vector((x,y,z))-Vector((n/2,n/2,n/2))
                        #if v.length<n*0.6: continue
                        if (abs(x-varX)<0.25*n) : continue
                    #blocks.append((x+dx*n,y+dy*n,z+dz*n,4))
                    pos = [x+dx*n,y+dy*n,z+dz*n,4]
                    if tuple(pos[:3]) not in blockSet:
                        blockSet.add(tuple(pos[:3]))
                        blocks.append(pos)

        r = int(random()*4)            
        for z in [1,0,-1]:
           
            #print(r)
            for x in range(0,n):
                for y in range(0,n):
                    if r==0 and ( abs(x-0.5*n) + abs(y-0.5*n) ) < n*0.5 : continue                    
                    blocks.append((x+dx*n,y+dy*n,z+dz*n,z+1))
    for z in [n,n-1]:
        for x in range(0,n):
            for y in range(0,n):
                if r==0 and ( abs(x-0.5*n) + abs(y-0.5*n) ) < n*0.5 : continue                    
                blocks.append((x+dx*n,y+dy*n,z+dz*n,3))
    return  blocks
