import os, sys, inspect
# realpath() will make your script run, even if you symlink it :)
cmd_folder = os.path.realpath(os.path.abspath(os.path.split(inspect.getfile( inspect.currentframe() ))[0]))
if cmd_folder not in sys.path:
    sys.path.insert(0, cmd_folder)

sys.path.append ( os.path.abspath(__file__).replace("operator_worker_client.py","")) 

# sys.stdout = open(os.devnull, "w")

from mapCreationLogic import worker_client
import random
class Worker_client:
    def __init__(self):
        self.server = worker_client.client(name="Worker"+str(random.randint(0,999)))
        self.server_iter = self.server.run()
    
    def check_server(self):
        if not next(self.server_iter ):
            self.server.kill()
            return False
        return True
    
from time import sleep

connection = Worker_client()

while connection.check_server():
    # print("Still alive")
    sleep(1.0/144)
            
    
       
