from socket import * 
from threading import *
import pickle,zlib
import time

DEBUG = 0

counter  = 0
message1 = "Nope"
seed = "THIS IS TEMP SEED"
chunkSize = 1
serverHealth = "Happy"
pendingTasks = set()
inWorkTasks = set()
doneTasks = set()
lock = Lock()
COMPRESSION = True

# import os,sys
# sys.stdout = open(os.devnull, "w")

def handler(clientsock,addr,BUFSIZ):
    global serverHealth, lock,pendingTasks,doneTasks,seed,inWorkTasks
    global chunkSize
    while 1:
        try:
            data = clientsock.recv(BUFSIZ)           
        except :
            print("Forcibly closed by the remote host")
            break   
        try:
            if COMPRESSION: data = zlib.decompress(   data  )
        except:
            print("server recieved nonsesnse\n\n")             
            break
        client = pickle.loads(data)   

        stateOfConnection = client["state"]

        if stateOfConnection == "/dead":
            break
        if stateOfConnection == "/kill":            
            lock.acquire()
            serverHealth    = "/kill"
            lock.release()  
            break    

        if client["name"][0] == "U": 
              
            requestTasks        = client["requestChunks"]

            # st = time.time()

            inProgressTasks     = inWorkTasks | doneTasks
            replyDoneTasks      = doneTasks & requestTasks

            lock.acquire() 

            pendingTasks        = requestTasks - inProgressTasks             
            
            seed = client["seed"]
            chunkSize = client["chunkSize"]
            lock.release()

            # et = time.time()
            # print( et-st )

            serverState = {"health":serverHealth,"pendingTasks":pendingTasks,"doneTasks":replyDoneTasks}
            serverStatePickled = pickle.dumps(serverState)
            if COMPRESSION: serverStatePickled = zlib.compress(serverStatePickled)
            clientsock.send(serverStatePickled)

       
        if client["name"][0] == "W":

            # print("worker")  
            # print("\n SERVER RECIEVED",client,"\n\n")  
                   

            task = set()

            lock.acquire() 

            doneTasks =  doneTasks.union(client["builtChunks"])
            inWorkTasks = inWorkTasks-doneTasks
            for batch in range(2):
                if len(pendingTasks):      
                    work = pendingTasks.pop()
                    inWorkTasks.add(work)          
                    task.add(work)

            # print(" SERVER done",doneTasks)    
            lock.release()

            
            serverState = {"health":serverHealth,"work":task,"seed":seed,"chunkSize":chunkSize}
            data = pickle.dumps(serverState)
            if COMPRESSION: data = zlib.compress(data)
            clientsock.send(data)

              

            
    print('Connection terminated')
    clientsock.close()
    

def start_server():
    
    HOST = '127.0.0.1'
    PORT = 9999
    BUFSIZ = 8192
    ADDR = (HOST, PORT)
    serversock = socket(AF_INET, SOCK_STREAM)
    serversock.bind(ADDR)
    serversock.listen(10)

    while serverHealth == "Happy":
        lock.acquire()
        print( "waiting for connection…")
        lock.release()
        clientsock, addr = serversock.accept()
        lock.acquire()
        print( "…connected from:", addr)
        lock.release()
        t = Thread(target=handler,  args=[clientsock, addr,BUFSIZ])
        t.start()
        
        
print("\n\n    Server START\n\n")
start_server()
